#!/usr/bin/nawk -f
# cdiff.awk V2.00 (C) yoshioka.teruo@nifty.com, 2003-11-04.
# cdiff.awk postprocesses output of diff
# Usage: cdiff.awk <input >output
function String(n,c){
  s="";
  for(k=0;k<n;k++){
    s=s c;
  }
  return(s);
}
function Fold(line){
  columns=0;
  n=1;
  while(n<=length(line)){
    char=substr(line,n,1);
    columns=columns+1;
    if(columns>NFL+COL){
      TwoUp(substr(line,1,n-1));
      line=String(NFL," ") substr(line,n);
      n=1;
      columns=1;
    }
    n=n+1;
  }
  TwoUp(line);
}
function TwoUp(line){
# flag = 0:common 1:left/old 2:right/new
  if(substr(line,1,7)=="#ifndef") flag=1;
  else if(substr(line,1,6)=="#ifdef") flag=2;
  else if(substr(line,1,5)=="#else") flag=2;
  else if(substr(line,1,6)=="#endif"){
    print smark;
    if(lcount>rcount) mcount=lcount;
    else mcount=rcount;
    for(i=0;i<mcount;i++){
      line=lmark;
      if(i<lcount){
        if(substr(lcode[i],1,NFL)==String(NFL,NFC)){
          lnumber++;
          lcode[i]=String(NFL-length(lnumber)-1,"0") lnumber " " substr(lcode[i],NFL+1);
        }
        line=line lcode[i] String(NFL+COL-length(lcode[i])," ");
      }else{
        line=line String(NFL+COL," ");
      }
      line=line cspace;
      if(i<rcount){
        if(substr(rcode[i],1,NFL)==String(NFL,NFC)){
          rnumber++;
          rcode[i]=String(NFL-length(rnumber)-1,"0") rnumber " " substr(rcode[i],NFL+1);
        }
        line=line rcode[i] String(NFL+COL-length(rcode[i])," ");
      }else{
        line=line String(NFL+COL," ");
      }
      line=line rmark;
      print line;
    }
    print emark;
    flag=0;
    lcount=0;
    rcount=0;
  }else if(flag==1){
    lcode[lcount++]=line;
  }else if(flag==2){
    rcode[rcount++]=line;
  }else{
    if(substr(line,1,NFL)==String(NFL,NFC)){
      lnumber++;
      lline=String(NFL-length(lnumber)-1,"0") lnumber " " substr(line,NFL+1);
      rnumber++;
      rline=String(NFL-length(rnumber)-1,"0") rnumber " " substr(line,NFL+1);
      print lspace lline String(NFL+COL-length(line)," ") cspace rline;
    }else{
      print lspace line String(NFL+COL-length(line)," ") cspace line;
    }
  }
}
BEGIN{
  NFL=5;
  COL=80;
  NFC="@";
  tabStop=8;
  TAB="\t";

# Variables For TwoUp
  lspace="  ";
  cspace="  ";
  lmark="| ";
  rmark=" |";
  smark="+-"  String(NFL+COL+2+NFL+COL,"-")  "-+";
  emark=smark;

  flag=0;
  lcount=0;
  rcount=0;
}
{
  line=$0;
  columns=0;
  str=substr(line,1,NFL);
  for(n=NFL+1;n<=length(line);n++){
    char=substr(line,n,1);
    if(char==TAB){
      m=tabStop-(columns-tabStop*int(columns/tabStop));
      str=str String(m," ");
      columns=columns+m;
    }else{
      str=str char;
      columns=columns+1;
    }
  }
  Fold(str);
}
