#!/usr/bin/nawk -f
# cdiffsum.awk V2.00 (C) yoshioka.teruo@nifty.com, 2003-11-04.
# cdiffsum.awk summarizes cdiff output
# Usage: cdiffsum.awk [-p] <input >output
BEGIN{
  PageLines=66;
  P=0;
  if(ARGC>0) P=1;
  lineCount=0;
  pageCount=1;
}
{
  line=$0;
  lineCount=lineCount+1;
  if(lineCount>PageLines){
    if(P && (page[pageCount]>0)){
      for(n=1;n<=PageLines;n++){
        print lines[n];
      }
    }
    pageCount=pageCount+1;
    lineCount=1;
    change=0;
  }
  lines[lineCount]=line;
  if(substr(line,1,2)!="  "){
    if(! change){
      page[pageCount]=page[pageCount]+1;
      change=1;
    }
  }else{
    change=0;
  }
}
END{
  if(P && (page[pageCount]>0)){
    for(n=1;n<=lineCount;n++){
      print lines[n];
    }
    for(n=1;n<=PageLines-lineCount;n++){
      print "";
    }
  }

  pages=0;
  change=0;
  for(n=1;n<=pageCount;n++){
    if(page[n]>0){
      pages=pages+1;
      change=change+page[n];
      print "Page : " n " ( " page[n] " ) ";
    }
  }
  print "Total : " pages " / " pageCount " ( " change  " ) ";
}
